<?php

namespace Drupal\emergya\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\Core\Link;
use Drupal\Core\Url;

/**
 * @method t(string $string)
 */
class RoleGroupDrupal extends ControllerBase
{

  public function listRoles() {

    $rolesCurrentUser = \Drupal::currentUser()->getRoles();
    $linkRoles = [];

    foreach ($rolesCurrentUser as $roles) {
      if (str_starts_with($roles, 'om_') || str_starts_with($roles, 'tm_')) {
        $url = Url::fromUri('/mis-grupos-drupal/'.$roles);
        $project_link = Link::fromTextAndUrl($roles, $url);
        $project_link = $project_link->toRenderable();
        $linkRoles[] = $project_link;
      }
    }

    // If you need some attributes.
   // $project_link['#attributes'] = array('class' => array('button', 'button-action', 'button--primary', 'button--small'));

    $build['content'] = [
      '#theme' => 'item_list',
      '#items' => $linkRoles,
    ];

    return $build;
  }



  public function getView($role) {

    $build['content'] = [
      '#type' => 'item',
      '#markup' => $role,
    ];

    return $build;
  }

}
