<?php

namespace Drupal\emergya\Controller;

use Drupal\Core\Controller\ControllerBase;
use Symfony\Component\DependencyInjection\ContainerInterface;
use Drupal\Core\Entity\EntityTypeManagerInterface;

/**
 * Returns responses for guifi·net routes.
 */
class SyncUserGroupsController extends ControllerBase {

  protected $entityTypeManager;
  public function __construct(EntityTypeManagerInterface $entityTypeManager)
  {
    $this->entityTypeManager = $entityTypeManager;
  }
  public static function create(ContainerInterface $container)
  {
    $entityTypeManager = $container->get('entity_type.manager');
    return new static($entityTypeManager);
  }

  /**
   * Builds the response.
   */
  public function syncUserGroups()
  {
    /*
    $servicio = \Drupal::service('emergya.api_groups');
    $data = $servicio->getGroups();
    foreach ($data as $row) {
      if (in_array('xavier.moragues', $row['users']) && (str_starts_with($row['id'],'om_') || str_starts_with($row['id'],'tm_')) ) {
        $group = $row['id'];
        $servicio->matchGroup($group, 'xavier.moragues');
      }
    }*/
    /**
     * Controlador para una importacion masiva de usuarios a miembros de grupo o
     * a typos de grupo por cada grupo keycloak y creacion de grupo por cada tipo de grupo y asociacion de sus miembros
     */
    $servicio = \Drupal::service('emergya.api_groups');
    $data = $servicio->getGroups();
    foreach ($data as $row) {
      if (str_starts_with($row['id'],'om_') || str_starts_with($row['id'],'tm_')) {

          $gType = \Drupal::entityTypeManager()->getStorage('group_type')->load($row['id']);
          if ($gType) {

          }
          else{
            //$newGroup = $newGroupType->create(['id' => $row['id'], 'label' => $row['id']]);
            //$newGroupType->save($newGroup);
            $newGroupType = \Drupal::entityTypeManager()->getStorage('group_type')->load('om');

            //$newGroupType->save($newGroup);
            $group_to_create = $this->entityTypeManager->getStorage('group')->create(
              ['type' => 'om',
               'label' => $row['id'],
              ],
            );
            $owner = $this->entityTypeManager->getStorage('user')->load(1);
            $group_to_create->setOwner($owner);
            $group_to_create->save();
            $storageGroup = $this->entityTypeManager->getStorage('group')->loadByProperties(['label' => $row['id'] ]);
            if ($group = reset($storageGroup)){
              foreach ($row['users'] as $user) {
                $userStorage = $this->entityTypeManager->getStorage('user')->loadByProperties(['name' => $user]);
                if ($user = reset($userStorage)){
                  $group->addMember($user);
                }
              }
              $group->save();
            }
            //$newGroup = $newGroupType->create(['id' => $row['id'], 'label' => $row['id']]);
            //$newGroupType->save($newGroup);
          }


      }

    }

    $build['content'] = [
      '#type' => 'item',
      '#markup' => $this->t('Sincronización completa'),
    ];

    return $build;
  }

  public function syncUserGroupsRoles(){

    $servicio = \Drupal::service('emergya.group_roles');
    $data = $servicio->getGroups();
    foreach ($data as $row) {
      if (str_starts_with($row['id'], 'om_') || str_starts_with($row['id'], 'tm_')) {
        foreach ($row['users'] as $user) {
          $userStorage = $this->entityTypeManager->getStorage('user')->loadByProperties(['name' => $user]);
          if ($user = reset($userStorage)){
            $msg = $servicio->syncRoles($row['id'],$user);
          }
        }
      }
    }


    $build['content2'] = [
      '#type' => 'item',
      '#markup' => $this->t('Sincronización completa de usuarios agrupados en Roles'),
    ];

    return $build;
  }

}
