(function ($, Drupal) {

  var wsProvince = drupalSettings.url_province;
  var wsCP = drupalSettings.url_cp;
  var fields = drupalSettings.fields;

  Drupal.behaviors.emergya_postal_code = {
    attach: function (context, settings) {
      $('input.postal-code', context).once('postal-code').each(function(index, element){
       $.each(fields, function (ind, elem) {
         var clase = elem.replace('_','-');
         $('input[name="' + elem + '[postal_code]"]').attr('pattern', '^(?:0[1-9]|[1-4]\\d|5[0-2])\\d{3}$' );
         $('input[name="' + elem + '[administrative_area]"]').prop('readonly', true);
         $('input[name="' + elem + '[postal_code]"]').change(function() {
           $('input[name="' + elem + '[locality]"]').prop('required',true);
           if ($('.' + clase + '-combo-aux').length){
             $('.' + clase + '-combo-aux').remove();
           }
           $('input[name="' + elem + '[locality]"]').prop('readonly', true);
           $('input[name="' + elem + '[locality]"]').val('');
           var cp = $('input[name="' + elem + '[postal_code]"]').val();
           $.ajax({
             url: wsCP.replace('[CP]', cp),
             type: 'GET',
             dataType: 'json',
             success: function (response) {
               if (response.nhits === 1 ){
                 $('select[name="' + elem + '[administrative_area]"]').val(response.records[0].fields.admin_name2);
                 var name_prov = response.records[0].fields.admin_name2;
                 var name_pobl = response.records[0].fields.place_name;
                 //$('select[name="' + elem + '[administrative_area]"] option[value]').attr("selected", "selected").remove();
                 $('select[name="' + elem + '[administrative_area]"] option[value=' + name_prov + ']').attr("selected", "selected");
                 $('select[name="' + elem + '[administrative_area]"]').attr("disabled", true);
                 $('input[name="' + elem + '[locality]"]').val(name_pobl);
                 $('input[name="' + elem + '[locality]"]').prop('readonly', true);
               }
               else{
                 if( response.nhits > 1) {
                   $('select[name="' + elem + '[administrative_area]"]').val(response.records[0].fields.admin_name2);
                   var name_prov = response.records[0].fields.admin_name2;
                   $('select[name="' + elem + '[administrative_area]"] option[value=' + name_prov + ']').attr("selected", "selected");
                   $('select[name="' + elem + '[administrative_area]"]').attr("disabled", true);
                  // console.log(response.facet_groups[1].facets);
                   var arr = [];
                   var datos = $(response.facet_groups[1].facets);

                   datos.each(function( index ) {
                     arr[index] =  {val : $( this )[0].name, text: $( this )[0].name};
                   });
                   var sel = $('<select>').appendTo('.form-item-' + clase + '-locality').css('display','block').addClass('' + clase + '-combo-aux');
                   var textPoblation = Drupal.t('Select a Poblation');
                   sel.append($("<option>").attr('value','').attr("selected", "selected").text(textPoblation));
                   $(arr).each(function(i) {
                       sel.append($("<option>").attr('value',this.val).text(this.text));
                   });
                   $('.' + clase + '-combo-aux').change(function() {
                     var poblacion = this.value;
                     $('input[name="' + elem + '[locality]"]').val(poblacion);
                     $('input[name="' + elem + '[locality]"]').prop('readonly', true);

                   });
                 }
               }
             }
           });

         });

         $(".webform-submission-form").submit(function(){
           $('select[name="' + elem + '[administrative_area]"]').attr("disabled", false);
         });
       });

      function ucwords(str,force){
        str=force ? str.toLowerCase() : str;
        return str.replace(/(\b)([a-zA-Z])/g,
          function(firstLetter){
            return   firstLetter.toUpperCase();
          });
      }
      });
    }
  };
})(jQuery, Drupal);
