<?php

namespace Drupal\emergya_postal_code\Services;

use Drupal;
use Drupal\Component\Serialization\Json;
use GuzzleHttp\ClientInterface;

class OpenData
{

  /**
   * @var ClientInterface
   */
  protected $httpClient;

  /**
   *
   * @param ClientInterface $http_client
   *
   */
  public function __construct(ClientInterface $http_client) {
    $this->httpClient = $http_client;
  }

  public function getProvince($cp){

    $url = "https://public.opendatasoft.com/api/records/1.0/search/?dataset=georef-spain-provincia&q=&rows=1&sort=prov_code&facet=prov_name&refine.prov_code=" . $cp;
    $request = $this->httpClient->request('GET', $url);

    if ($request->getStatusCode() == 200){
      $body = $request->getBody();
      $param = Json::decode($body);
      return $param['records'][0]['fields']['prov_name'];
    }
    return '';
  }
  public function getProvinceTown($cp){
    //TODO cambiar valor pais por parámetro
    $url = "https://public.opendatasoft.com//api/records/1.0/search/?dataset=geonames-postal-code&q=&facet=country_code&facet=admin_name1&facet=admin_code1&facet=admin_name2&refine.postal_code=" . $cp ."&refine.country_code=ES";
    $request = $this->httpClient->request('GET', $url);

    if ($request->getStatusCode() == 200){
      $body = $request->getBody();
      $param = Json::decode($body);
      $result = [
        'province' => $param['records'][0]['fields']['admin_name2'],
        'town' => $param['records'][0]['fields']['place_name'],
      ];

      return $result;
    }
    return '';
  }


}
