<?php

namespace Drupal\guifi\Entity;

use Drupal\Core\Config\Entity\ConfigEntityBundleBase;

/**
 * Defines the guifi type configuration entity.
 *
 * @ConfigEntityType(
 *   id = "guifi_type",
 *   label = @Translation("guifi type"),
 *   handlers = {
 *     "form" = {
 *       "add" = "Drupal\guifi\Form\GuifiTypeForm",
 *       "edit" = "Drupal\guifi\Form\GuifiTypeForm",
 *       "delete" = "Drupal\Core\Entity\EntityDeleteForm",
 *     },
 *     "list_builder" = "Drupal\guifi\GuifiTypeListBuilder",
 *     "route_provider" = {
 *       "html" = "Drupal\Core\Entity\Routing\AdminHtmlRouteProvider",
 *     }
 *   },
 *   admin_permission = "administer guifi types",
 *   bundle_of = "guifi",
 *   config_prefix = "guifi_type",
 *   entity_keys = {
 *     "id" = "id",
 *     "label" = "label",
 *     "uuid" = "uuid"
 *   },
 *   links = {
 *     "add-form" = "/admin/structure/guifi_types/add",
 *     "edit-form" = "/admin/structure/guifi_types/manage/{guifi_type}",
 *     "delete-form" = "/admin/structure/guifi_types/manage/{guifi_type}/delete",
 *     "collection" = "/admin/structure/guifi_types"
 *   },
 *   config_export = {
 *     "id",
 *     "label",
 *     "uuid",
 *   }
 * )
 */
class GuifiType extends ConfigEntityBundleBase {

  /**
   * The machine name of this guifi type.
   *
   * @var string
   */
  protected $id;

  /**
   * The human-readable name of the guifi type.
   *
   * @var string
   */
  protected $label;

}
